#  ATContentTypes http://sf.net/projects/collective/
#  Archetypes reimplementation of the CMF core types
#  Copyright (c) 2003-2006 AT Content Types development team
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
from zope.interface import Interface, Attribute
from Products.ATContentTypes.interface.interfaces import IATContentType


class IFilterFolder(Interface):

    def listObjects():
        """
        return the list of filtered object without looking at security
        """

    def listPermittedObjects():
        """
        return the list of filtered object and looking at security
        """

    def filter(context):
        """
        filter the objects in the context to be walked by TreeWalker.
        This method is private and shouldnt be called from outside.
        Use listObjects() instead
        """

class IATFolder(IATContentType):
    """AT Folder marker interface
    """

class IATBTreeFolder(IATContentType):
    """AT BTree Folder marker interface
    """


